% ETH ASL Beamer theme
% Written by Katie Jones
% 2016/08/01

\ProvidesPackage{beamerthemeeth}[2016/08/01]

\RequirePackage{tikz}
\RequirePackage{iftex}
\RequirePackage[export]{adjustbox}
\usetikzlibrary{calc}

\AtBeginDocument{\setbeamertemplate{logo}{}}

\def\itemcolor{itemsblue}
\DeclareOption{itemsblack}{\def\itemcolor{itemsblack}}
\DeclareOption{itemsblue}{\def\itemcolor{itemsblue}}
\def\titlecolor{titlesblack}
\DeclareOption{titlesblack}{\def\titlecolor{titlesblack}}
\DeclareOption{titlesblue}{\def\titlecolor{titlesblue}}
\ProcessOptions

% -> Begin \ProvidesPackage{beamercolorthemeeth}[2016/08/01]
\newif\if@itemsblack
\@itemsblackfalse
\DeclareOption{itemsblack}{\@itemsblacktrue}
\DeclareOption{itemsblue}{\@itemsblackfalse}

\newif\if@titlesblack
\@titlesblacktrue
\DeclareOption{titlesblack}{\@titlesblacktrue}
\DeclareOption{titlesblue}{\@titlesblackfalse}
\ProcessOptions

\definecolor{ETHblue}{RGB}{31,64,122}      % ETH1
\definecolor{ETHgreen}{RGB}{72,90,44}       % ETH2
\definecolor{ETHlightblue}{RGB}{18,105,176}     % ETH3
\definecolor{ETHdarkgreen}{RGB}{114,121,28}     % ETH4
\definecolor{ETHpurple}{RGB}{145,5,106}      % ETH5
\definecolor{ETHgray}{RGB}{111,111,100}    % ETH6
\definecolor{ETHblue}{RGB}{43,91,132}      % ETH7(43, 91, 132)
\definecolor{ETHlightishblue}{RGB}{0,122,150}      % ETH8
\definecolor{ETHorange}{RGB}{149,96,19}      % ETH9

\usecolortheme[named=ETHlightblue]{structure}

\setbeamercolor{normal text}{fg=black, bg=}
\setbeamercolor{title}{fg=white}
\setbeamercolor{title page}{fg=white,bg=structure}

\if@itemsblack
\setbeamercolor{item}{parent={normal text}}
\fi

\if@titlesblack
\setbeamercolor{frametitle}{fg=black}
\setbeamercolor{framesubtitle}{fg=gray}
\else
\setbeamercolor{framesubtitle}{fg=ETHlightblue!70!white}
\fi
% <- End \ProvidesPackage{beamercolorthemeeth}[2016/08/01]

% -> Begin \ProvidesPackage{beamerfontthemeeth}[2016/08/01]
\setbeamerfont{title}{series=\bfseries,size=\Large}
\setbeamerfont{author}{series=\bfseries,size=\Large}
\setbeamerfont{institute}{size=\normalsize}
\setbeamerfont{frametitle}{size=\Large,series=\bfseries}
\setbeamerfont{framesubtitle}{size=\large,series=\bfseries}
\setbeamerfont{footline}{size=\tiny}
% <- End \ProvidesPackage{beamerfontthemeeth}[2016/08/01]

\newcommand{\@supervisor}{}
\newcommand{\supervisor}[1]{\renewcommand{\@supervisor}{#1}}
\newcommand{\supervisors}[1]{\renewcommand{\@supervisor}{#1}}

\def\@projecttype{}
\def\projecttype#1{\def\@projecttype{#1}}

% Sizes
\setbeamersize{text margin left=0.05\paperwidth, text margin right=0.05\paperwidth}

\setbeamertemplate{navigation symbols}{}
\setbeamertemplate{itemize items}[circle]
\setbeamertemplate{background canvas}[vertical shading][bottom=white,top=white]

\setbeamertemplate{footline}{
  \hspace{0.02\paperwidth}
%   \includegraphics[height=2em,valign=b]{asl_logo_right.pdf}
  \hfill \parbox{0.5\textwidth}{\hfill \insertauthor~~|~~\insertinstitute~~|~~\insertframenumber~~/~~\inserttotalframenumber \hspace{0.02\paperwidth}
  \vspace{0.01\paperwidth}}
}

\setbeamertemplate{title page}{
  \usebeamercolor{title page}
  \begin{tikzpicture}[remember picture]
    \useasboundingbox (0,0) rectangle ++($0.92*(\the\paperwidth,0) - 0.25*(0,\the\paperheight)$);
    \node[inner sep=0pt,below] (titlepic) at ($0.5*(bottomleft) + 0.5*(bottomright)$) {\includegraphics[width=\paperwidth,trim={0mm 45mm 0mm 36mm}]{image/title.jpg}};
    \useasboundingbox (titlepic.north west) rectangle (titlepic.south east);
  \end{tikzpicture}
  \begin{tikzpicture}[overlay,remember picture]
    \draw[ETHblue,fill=ETHblue] (-4mm,-40mm)--(119.0mm,-40mm)--(119.0mm,-10mm)--(-4mm,-10mm);
    \node [shift={(-20mm,-75.5mm)}]  at (current page.north east){\includegraphics[width=30mm]{image/ccsl-logo.png}};%
    \node [shift={(-52mm,-76.5mm)}]  at (current page.north east){\includegraphics[width=30mm]{image/proex-logo.png}};%
  \end{tikzpicture}
  %% Title
  \newlength{\oldparskip}
  \setlength{\oldparskip}{\parskip}
  \setlength{\parskip}{1.5em}
  {\vfill\usebeamercolor{author}\usebeamerfont{author}\inserttitle\\}
  {%% Subtitle
    \ifx\insertsubtitle\@empty%
    \else%
    \usebeamerfont{subtitle}\usebeamercolor[fg]{subtitle}\insertsubtitle\par
    \fi%  
  }
  %% Author
  {\usebeamercolor{institute}\usebeamerfont{institute}\insertauthor}\par
  %% Type of project
  \vfill
  \ifx\@projecttype\@empty\else
  {\usebeamercolor{institute}\usebeamerfont{institute}\@projecttype}\\
  \fi
  {\usebeamercolor{institute}\usebeamerfont{institute}\@supervisor}
  %% Date
  % {\usebeamercolor{date}\usebeamerfont{date} \insertdate}
  \setlength{\parskip}{\oldparskip}
}

\setbeamertemplate{headline}{
  \centering
  \begin{tikzpicture}[remember picture]
    \useasboundingbox (0,\the\paperheight) rectangle ++($(\the\paperwidth,0) - 0.1*(0,\the\paperwidth)$);
    \coordinate (topleft) at ($(0,\the\paperheight) + 0.02*(\the\paperwidth,-\the\paperwidth)$);
    \coordinate (bottomright) at ($(\the\paperwidth,\the\paperheight)-0.02*(\the\paperwidth,\the\paperwidth) - 0.05*(0,\the\paperwidth)$);
    \coordinate (bottomleft) at (topleft |- bottomright); 
    {\usebeamercolor[bg]{title page}
    \fill (topleft) rectangle (bottomright);
    \fill (bottomleft) rectangle ++($0.02*(\the\paperwidth,-\the\paperwidth)$) coordinate (bottominsideleft);
    \fill (bottomright) rectangle ++($0.02*(-\the\paperwidth,-\the\paperwidth)$) coordinate (bottominsideright);
  }
  \node at ($0.0*(topleft) + 0.035*(bottomleft) + 0.08*(\the\paperwidth,0)$) {\includegraphics[height=0.035\paperwidth]{image/python-logo.png}};
\end{tikzpicture}
}

\setbeamertemplate{frametitle}{
  {\usebeamercolor[fg]{frametitle}\usebeamerfont{frametitle}\insertframetitle\par}%
  {\usebeamercolor[fg]{framesubtitle}\usebeamerfont{framesubtitle}\insertframesubtitle\par}%
}
